package formes;

import java.awt.geom.Point2D;
import java.util.Objects;

public class Rectangle {
	private double hauteur;
	private double largeur;
	private Point2D centreGravite;

	public Rectangle(Point2D p, double hauteur, double largeur) {
		centreGravite = (Point2D) p.clone();
		this.hauteur = hauteur;
		this.largeur = largeur;
	}

	public double hauteur() {
		return hauteur;
	}
	
	public double largeur() {
		return largeur;
	}
	
	public Point2D centreGravite() {
		return (Point2D) centreGravite.clone();
	}
	
	public double perimetre() {
		return 2. * (hauteur + largeur);
	}

	public double surface() {
		return hauteur * largeur;
	}

	public void placer(Point2D nouveauCentreGravite) {
		centreGravite.setLocation(nouveauCentreGravite);
	}

	public void translater(double dx, double dy) {
		centreGravite.setLocation(centreGravite.getX() + dx, centreGravite.getY() + dy);
	}

	public void changerHauteur(double nouvelleHauteur) {
		hauteur = nouvelleHauteur;
	}

	public void changerLargeur(double nouvelleLargeur) {
		largeur = nouvelleLargeur;
	}
	
	public String toString() {
		return "Rectangle de centre (" + centreGravite.getX() + ", " + centreGravite.getY() + ") de largeur " + largeur
				+ " et de hauteur " + hauteur;
	}

	public boolean equals(Object o) {
		if (!(o instanceof Rectangle))
			return false;
		Rectangle r = (Rectangle) o;
		return centreGravite.equals(r.centreGravite) && hauteur == r.hauteur && largeur == r.largeur;
	}

	public int hashCode() {
		return Objects.hash(centreGravite, largeur, hauteur);
	}

}